Index: admin/preferences.php
===================================================================
--- admin/preferences.php	(revision 1609)
+++ admin/preferences.php	(revision 1726)
@@ -56,11 +56,8 @@
 }
 
-foreach ($core->getFormaters() as $v) {
-	$formaters_combo[$v] = $v;
-}
-
-foreach ($core->blog->getAllPostStatus() as $k => $v) {
-	$status_combo[$v] = $k;
-}
+# Formaters combo
+$formaters_combo = dcAdminCombos::getFormatersCombo();
+
+$status_combo = dcAdminCombos::getPostStatusescombo();
 
 $iconsets_combo = array(__('Default') => '');
@@ -77,9 +74,5 @@
 
 # Language codes
-$langs = l10n::getISOcodes(1,1);
-foreach ($langs as $k => $v) {
-	$lang_avail = $v == 'en' || is_dir(DC_L10N_ROOT.'/'.$v);
-	$lang_combo[] = new formSelectOption($k,$v,$lang_avail ? 'avail10n' : '');
-}
+$lang_combo = dcAdminCombos::getAdminLangsCombo();
 
 # Add or update user
@@ -409,5 +402,12 @@
 
 '<p><label for="user_url">'.__('URL:').'</label>'.
-form::field('user_url',30,255,html::escapeHTML($user_url)).'</p>';
+form::field('user_url',30,255,html::escapeHTML($user_url)).'</p>'.
+
+'<p><label for="user_lang">'.__('Language for my interface:').'</label>'.
+form::combo('user_lang',$lang_combo,$user_lang,'l10n').'</p>'.
+
+'<p><label for="user_tz">'.__('My timezone:').'</label>'.
+form::combo('user_tz',dt::getZones(true,true),$user_tz).'</p>';
+
 
 if ($core->auth->allowPassChange())
@@ -456,10 +456,4 @@
 '<h4>'.__('Interface').'</h4>'.
 
-'<p><label for="user_lang">'.__('Language for my interface:').'</label>'.
-form::combo('user_lang',$lang_combo,$user_lang,'l10n').'</p>'.
-
-'<p><label for="user_tz">'.__('My timezone:').'</label>'.
-form::combo('user_tz',dt::getZones(true,true),$user_tz).'</p>'.
-
 '<p><label for="user_ui_enhanceduploader" class="classic">'.
 form::checkbox('user_ui_enhanceduploader',1,$user_ui_enhanceduploader).' '.
Index: admin/user.php
===================================================================
--- admin/user.php	(revision 1621)
+++ admin/user.php	(revision 1719)
@@ -32,18 +32,11 @@
 $user_options = $core->userDefaults();
 
-foreach ($core->getFormaters() as $v) {
-	$formaters_combo[$v] = $v;
-}
-
-foreach ($core->blog->getAllPostStatus() as $k => $v) {
-	$status_combo[$v] = $k;
-}
+# Formaters combo
+$formaters_combo = dcAdminCombos::getFormatersCombo();
+
+$status_combo = dcAdminCombos::getPostStatusesCombo();
 
 # Language codes
-$langs = l10n::getISOcodes(1,1);
-foreach ($langs as $k => $v) {
-	$lang_avail = $v == 'en' || is_dir(DC_L10N_ROOT.'/'.$v);
-	$lang_combo[] = new formSelectOption($k,$v,$lang_avail ? 'avail10n' : '');
-}
+$lang_combo = dcAdminCombos::getAdminLangsCombo();
 
 # Get user if we have an ID
Index: debian/control
===================================================================
--- debian/control	(revision 0)
+++ debian/control	(revision 1743)
@@ -8,5 +8,5 @@
 Package: dotclear
 Architecture: all
-Depends: ${misc:Depends}, apache2 | httpd | apache, libclearbricks, php5-pgsql | php5-sqlite | php5-mysql, php5-gd
+Depends: ${misc:Depends}, apache2 | httpd | apache, libclearbricks, php5-pgsql | php5-sqlite | php5-mysql | php5-mysqli, php5-gd
 Suggests: php5-tidy
 Description: DotClear 2
Index: inc/admin/lib.admincombos.php
===================================================================
--- inc/admin/lib.admincombos.php	(revision 1722)
+++ inc/admin/lib.admincombos.php	(revision 1722)
@@ -0,0 +1,175 @@
+<?php
+# -- BEGIN LICENSE BLOCK ---------------------------------------
+#
+# This file is part of Dotclear 2.
+#
+# Copyright (c) 2003-2013 Olivier Meunier & Association Dotclear
+# Licensed under the GPL version 2.0 license.
+# See LICENSE file or
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+#
+# -- END LICENSE BLOCK -----------------------------------------
+if (!defined('DC_RC_PATH')) { return; }
+/**
+@ingroup DC_CORE
+@nosubgrouping
+@brief Admin combo library 
+
+Dotclear utility class that provides reuseable combos across all admin
+
+*/
+class dcAdminCombos {
+
+	/** @var dcCore dcCore instance */
+	public static $core;
+	
+	/**
+	Returns an hierarchical categories combo from a category record
+	
+	@param	categories		<b>record</b>		the category record
+	@return	<b>array</b> the combo box (form::combo -compatible format)
+	*/
+	public static function getCategoriesCombo($categories) {
+		$categories_combo[__('(No cat)')] = '';
+		while ($categories->fetch()) {
+			$categories_combo[str_repeat('&nbsp;&nbsp;',$categories->level-1).($categories->level-1 == 0 ? '' : '&bull; ').
+				html::escapeHTML($categories->cat_title).
+				' ('.$categories->nb_post.')'] = $categories->cat_id;
+		}
+		return $categories_combo;
+	}
+	
+	/**
+	Returns available post status combo 
+	
+	@return	<b>array</b> the combo box (form::combo -compatible format)
+	*/
+	public static function getPostStatusesCombo() {
+		$status_combo =  array();
+		foreach (self::$core->blog->getAllPostStatus() as $k => $v) {
+			$status_combo[$v] = (string) $k;
+		}
+		return $status_combo;
+	}
+	
+	/**
+	Returns an users combo from a users record
+	
+	@param	users		<b>record</b>		the users record
+	@return	<b>array</b> the combo box (form::combo -compatible format)
+	*/
+	public static function getUsersCombo($users) {
+		$users_combo = array();
+		while ($users->fetch())
+		{
+			$user_cn = dcUtils::getUserCN($users->user_id,$users->user_name,
+			$users->user_firstname,$users->user_displayname);
+			
+			if ($user_cn != $users->user_id) {
+				$user_cn .= ' ('.$users->user_id.')';
+			}
+			
+			$users_combo[$user_cn] = $users->user_id; 
+		}
+		return $users_combo;
+	}
+	
+	/**
+	Returns an date combo from a date record
+	
+	@param	dates		<b>record</b>		the dates record
+	@return	<b>array</b> the combo box (form::combo -compatible format)
+	*/	
+	public static function getDatesCombo($dates) {
+		$dt_m_combo= array();
+		while ($dates->fetch()) {
+			$dt_m_combo[dt::str('%B %Y',$dates->ts())] = $dates->year().$dates->month();
+		}		
+		return $dt_m_combo;
+	}
+	
+	/**
+	Returns an lang combo from a lang record
+	
+	@param	langs		<b>record</b>		the langs record
+	@param	with_available	<b>boolean</b>	if false, only list items from record
+											if true, also list available languages
+	@return	<b>array</b> the combo box (form::combo -compatible format)
+	*/	
+	public static function getLangsCombo($langs,$with_available=false) {
+		$all_langs = l10n::getISOcodes(0,1);
+		if ($with_available) {
+			$langs_combo = array('' => '', __('Most used') => array(), __('Available') => l10n::getISOcodes(1,1));
+			while ($langs->fetch()) {
+				if (isset($all_langs[$langs->post_lang])) {
+					$langs_combo[__('Most used')][$all_langs[$langs->post_lang]] = $langs->post_lang;
+					unset($langs_combo[__('Available')][$all_langs[$langs->post_lang]]);
+				} else {
+					$langs_combo[__('Most used')][$langs->post_lang] = $langs->post_lang;
+				}
+			}
+		} else {
+			$langs_combo = array();
+			while ($langs->fetch()) {
+				$lang_name = isset($all_langs[$langs->post_lang]) ? $all_langs[$langs->post_lang] : $langs->post_lang;
+				$langs_combo[$lang_name] = $langs->post_lang;
+			}
+		}
+		unset($all_langs);
+		return $langs_combo;
+	}
+	
+	/**
+	Returns a combo containing all available and installed languages for administration pages
+	
+	@return	<b>array</b> the combo box (form::combo -compatible format)
+	*/	
+	public static function getAdminLangsCombo() {
+		$lang_combo = array();
+		$langs = l10n::getISOcodes(1,1);
+		foreach ($langs as $k => $v) {
+			$lang_avail = $v == 'en' || is_dir(DC_L10N_ROOT.'/'.$v);
+			$lang_combo[] = new formSelectOption($k,$v,$lang_avail ? 'avail10n' : '');
+		}
+		return $lang_combo;
+	}
+	
+	/**
+	Returns a combo containing all available formaters in admin
+	
+	@return	<b>array</b> the combo box (form::combo -compatible format)
+	*/	
+	public static function getFormatersCombo() {
+		foreach (self::$core->getFormaters() as $v) {
+			$formaters_combo[$v] = $v;
+		}
+		return $formaters_combo;
+	}
+	
+	/**
+	Returns a combo containing available blog statuses
+	
+	@return	<b>array</b> the combo box (form::combo -compatible format)
+	*/	
+	public static function getBlogStatusesCombo() {
+		$status_combo = array();
+		foreach (self::$core->getAllBlogStatus() as $k => $v) {
+			$status_combo[$v] = (string) $k;
+		}
+		return $status_combo;
+	}
+	
+	/**
+	Returns a combo containing available comment statuses
+	
+	@return	<b>array</b> the combo box (form::combo -compatible format)
+	*/	
+	public static function getCommentStatusescombo() {
+		$status_combo = array();
+		foreach (self::$core->blog->getAllCommentStatus() as $k => $v) {
+			$status_combo[$v] = (string) $k;
+		}
+		return $status_combo;
+	}
+}
+dcAdminCombos::$core = $GLOBALS['core'];
Index: inc/admin/lib.dc.page.php
===================================================================
--- inc/admin/lib.dc.page.php	(revision 1699)
+++ inc/admin/lib.dc.page.php	(revision 1741)
@@ -150,7 +150,7 @@
 
 		echo
-		'<div id="wrapper">'."\n".
+		'<div id="wrapper" class="clearfix">'."\n".
 		'<div id="main">'."\n".
-		'<div id="content">'."\n";
+		'<div id="content" class="clearfix">'."\n";
 
 		# Safe mode
@@ -330,4 +330,9 @@
 	{
 		self::message($msg,$timestamp,$div,$echo,"success");
+	}
+
+	public static function warning($msg,$timestamp=true,$div=false,$echo=true)
+	{
+		self::message($msg,$timestamp,$div,$echo,"warning-msg");
 	}
 
@@ -613,8 +618,20 @@
 		"//<![CDATA[\n".
 		"\$(function() {\n".
-			"	\$.pageTabs(".$default.");\n".
+			"	pagetabs = \$.pageTabs(".$default.");\n".
 			"});\n".
 "\n//]]>\n".
-"</script>\n";
+"</script>\n".
+		"<!--[if lt IE 8]>\n".
+		self::jsLoad('js/ie7/ie7-hashchange.js').
+		'<script type="text/javascript">'."\n".
+		"//<![CDATA[\n".
+		"\$(function() {".
+			"\$(window).hashchange( function(){".
+				"pagetabs.showDiv(document.location.hash.split('#').join(''));".
+			"});".
+		"});".
+		"\n//]]>\n".
+		"</script>\n".
+		"<![endif]-->\n";
 }
 
Index: inc/config.php.in
===================================================================
--- inc/config.php.in	(revision 1535)
+++ inc/config.php.in	(revision 1743)
@@ -12,5 +12,5 @@
 if (!defined('DC_RC_PATH')) { return; }
 
-// Database driver (mysql, pgsql, sqlite)
+// Database driver (mysql, mysqli, pgsql, sqlite)
 define('DC_DBDRIVER','');
 
Index: inc/core/class.dc.blog.php
===================================================================
--- inc/core/class.dc.blog.php	(revision 1689)
+++ inc/core/class.dc.blog.php	(revision 1743)
@@ -658,5 +658,5 @@
 		if (!$rs->isEmpty())
 		{
-			if ($this->con->driver() == 'mysql') {
+			if ($this->con->driver() == 'mysql' || $this->con->driver() == 'mysqli') {
 				$clause = "REGEXP '^".$this->con->escape($url)."[0-9]+$'";
 			} elseif ($this->con->driver() == 'pgsql') {
@@ -1828,5 +1828,5 @@
 		if (!$rs->isEmpty())
 		{
-			if ($this->con->driver() == 'mysql') {
+			if ($this->con->driver() == 'mysql' || $this->con->driver() == 'mysqli') {
 				$clause = "REGEXP '^".$this->con->escape($url)."[0-9]+$'";
 			} elseif ($this->con->driver() == 'pgsql') {
@@ -2187,5 +2187,5 @@
 		
 		# mySQL uses "JOIN" synthax
-		if ($this->con->driver() == 'mysql') {
+		if ($this->con->driver() == 'mysql' || $this->con->driver() == 'mysqli') {
 			$strReq .= 
 				'JOIN '.$this->prefix.'post tp ON tc.post_id = tp.post_id ';
@@ -2196,5 +2196,5 @@
 		
 		# pgSQL uses "FROM" synthax
-		if ($this->con->driver() != 'mysql') {
+		if ($this->con->driver() != 'mysql' || $this->con->driver() == 'mysqli') {
 			$strReq .= 
 				'FROM '.$this->prefix.'post tp ';
@@ -2206,5 +2206,5 @@
 		
 		# add pgSQL "WHERE" clause
-		if ($this->con->driver() != 'mysql') {
+		if ($this->con->driver() != 'mysql' || $this->con->driver() == 'mysqli') {
 			$strReq .= 
 				'AND tc.post_id = tp.post_id ';
@@ -2265,5 +2265,5 @@
 		
 		# mySQL uses "INNER JOIN" synthax
-		if ($this->con->driver() == 'mysql') {
+		if ($this->con->driver() == 'mysql' || $this->con->driver() == 'mysqli') {
 			$strReq = 
 				'DELETE FROM tc '.
@@ -2302,5 +2302,5 @@
 		
 		# mySQL uses "INNER JOIN" synthax
-		if ($this->con->driver() == 'mysql') {
+		if ($this->con->driver() == 'mysql' || $this->con->driver() == 'mysqli') {
 			$strReq = 
 				'DELETE FROM tc '.
Index: inc/core/class.dc.core.php
===================================================================
--- inc/core/class.dc.core.php	(revision 1698)
+++ inc/core/class.dc.core.php	(revision 1743)
@@ -64,4 +64,6 @@
 		if ($this->con instanceof mysqlConnection) {
 			mysqlConnection::$weak_locks = true;
+		} elseif ($this->con instanceof mysqliConnection) {
+			mysqliConnection::$weak_locks = true;
 		}
 		
Index: inc/core/class.dc.media.php
===================================================================
--- inc/core/class.dc.media.php	(revision 1468)
+++ inc/core/class.dc.media.php	(revision 1718)
@@ -74,5 +74,10 @@
 		
 		if (!is_dir($root)) {
-			throw new Exception(sprintf(__('Directory %s does not exist.'),$root));
+			# Check public directory
+			if ( $core->auth->isSuperAdmin() ) {
+				throw new Exception(__("There is no writable directory /public/ at the location set in about:config \"public_path\". You must create this directory with sufficient rights (or change this setting)."));
+			} else {
+				throw new Exception(__("There is no writable root directory for the media manager. You should contact your administrator."));
+			}
 		}
 		
@@ -299,5 +304,7 @@
 			$f->media_thumb = array();
 			$p = path::info($f->relname);
+
 			$alpha = ($p['extension'] == 'png') || ($p['extension'] == 'PNG');
+
 			$thumb = sprintf(($alpha ? $this->thumb_tp_alpha : $this->thumb_tp),$this->root.'/'.$p['dirname'],$p['base'],'%s');
 			$thumb_url = sprintf(($alpha ? $this->thumb_tp_alpha : $this->thumb_tp),$this->root_url.$p['dirname'],$p['base'],'%s');
@@ -306,8 +313,18 @@
 			$thumb_url = preg_replace('#\./#','/',$thumb_url);
 			$thumb_url = preg_replace('#(?<!:)/+#','/',$thumb_url);
+
+			if ($alpha) {
+				$thumb_alt = sprintf($this->thumb_tp,$this->root.'/'.$p['dirname'],$p['base'],'%s');
+				$thumb_url_alt = sprintf($this->thumb_tp,$this->root_url.$p['dirname'],$p['base'],'%s');
+				# Cleaner URLs
+				$thumb_url_alt = preg_replace('#\./#','/',$thumb_url_alt);
+				$thumb_url_alt = preg_replace('#(?<!:)/+#','/',$thumb_url_alt);
+			}
 			
 			foreach ($this->thumb_sizes as $suffix => $s) {
 				if (file_exists(sprintf($thumb,$suffix))) {
 					$f->media_thumb[$suffix] = sprintf($thumb_url,$suffix);
+				} elseif ($alpha && file_exists(sprintf($thumb_alt,$suffix))) {
+					$f->media_thumb[$suffix] = sprintf($thumb_url_alt,$suffix);
 				}
 			}
Index: inc/prepend.php
===================================================================
--- inc/prepend.php	(revision 1694)
+++ inc/prepend.php	(revision 1719)
@@ -59,4 +59,5 @@
 $__autoload['adminCommentList']		= dirname(__FILE__).'/admin/lib.pager.php';
 $__autoload['adminUserList']			= dirname(__FILE__).'/admin/lib.pager.php';
+$__autoload['dcAdminCombos']			= dirname(__FILE__).'/admin/lib.admincombos.php';
 
 $__autoload['dcTemplate']			= dirname(__FILE__).'/public/class.dc.template.php';
Index: plugins/importExport/inc/class.dc.import.wp.php
===================================================================
--- plugins/importExport/inc/class.dc.import.wp.php	(revision 1622)
+++ plugins/importExport/inc/class.dc.import.wp.php	(revision 1719)
@@ -80,8 +80,6 @@
 			$this->post_limit = $this->vars['post_limit'];
 		}
-		
-		foreach ($this->core->getFormaters() as $v) {
-			$this->formaters[$v] = $v;
-		}
+
+		$this->formaters = dcAdminCombos::getFormatersCombo();
 	}
 	
Index: plugins/importExport/inc/flat/class.flat.import.php
===================================================================
--- plugins/importExport/inc/flat/class.flat.import.php	(revision 1093)
+++ plugins/importExport/inc/flat/class.flat.import.php	(revision 1743)
@@ -160,5 +160,5 @@
 					if (in_array($last_line_name,$constrained)) {
 						# UNDEFER
-						if ($this->con->driver() == 'mysql') $this->con->execute('SET foreign_key_checks = 1');
+						if ($this->con->driver() == 'mysql' || $this->con->driver() == 'mysqli') $this->con->execute('SET foreign_key_checks = 1');
 						if ($this->con->driver() == 'pgsql') $this->con->execute('SET CONSTRAINTS ALL DEFERRED');
 					}
@@ -166,5 +166,5 @@
 					if (in_array($line->__name,$constrained)) {
 						# DEFER
-						if ($this->con->driver() == 'mysql') $this->con->execute('SET foreign_key_checks = 0');
+						if ($this->con->driver() == 'mysql' || $this->con->driver() == 'mysqli') $this->con->execute('SET foreign_key_checks = 0');
 						if ($this->con->driver() == 'pgsql') $this->con->execute('SET CONSTRAINTS ALL IMMEDIATE');
 					}
@@ -205,5 +205,5 @@
 			}
 			
-			if ($this->con->driver() == 'mysql') $this->con->execute('SET foreign_key_checks = 1');
+			if ($this->con->driver() == 'mysql' || $this->con->driver() == 'mysqli') $this->con->execute('SET foreign_key_checks = 1');
 			if ($this->con->driver() == 'pgsql') $this->con->execute('SET CONSTRAINTS ALL DEFERRED');
 		}
Index: plugins/pages/page.php
===================================================================
--- plugins/pages/page.php	(revision 1713)
+++ plugins/pages/page.php	(revision 1741)
@@ -53,28 +53,15 @@
 
 # Status combo
-foreach ($core->blog->getAllPostStatus() as $k => $v) {
-	$status_combo[$v] = (string) $k;
-}
+$status_combo = dcAdminCombos::getPostStatusesCombo();
+
 $img_status_pattern = '<img class="img_select_option" alt="%1$s" title="%1$s" src="images/%2$s" />';
 
 # Formaters combo
-foreach ($core->getFormaters() as $v) {
-	$formaters_combo[$v] = $v;
-}
+$formaters_combo = dcAdminCombos::getFormatersCombo();
 
 # Languages combo
 $rs = $core->blog->getLangs(array('order'=>'asc'));
-$all_langs = l10n::getISOcodes(0,1);
-$lang_combo = array('' => '', __('Most used') => array(), __('Available') => l10n::getISOcodes(1,1));
-while ($rs->fetch()) {
-	if (isset($all_langs[$rs->post_lang])) {
-		$lang_combo[__('Most used')][$all_langs[$rs->post_lang]] = $rs->post_lang;
-		unset($lang_combo[__('Available')][$all_langs[$rs->post_lang]]);
-	} else {
-		$lang_combo[__('Most used')][$rs->post_lang] = $rs->post_lang;
-	}
-}
-unset($all_langs);
-unset($rs);
+$lang_combo = dcAdminCombos::getLangsCombo($rs,true);
+
 
 # Validation flag
@@ -480,6 +467,6 @@
 		
 		"post_excerpt" =>
-			'<p class="area" id="excerpt-area"><label for="post_excerpt">'.__('Excerpt:').'<span class="form-note">'.
-			__('Add an introduction to the post.').'</span></label> '.
+			'<p class="area" id="excerpt-area"><label for="post_excerpt">'.__('Excerpt:').' <span class="form-note">'.
+			__('Introduction to the post.').'</span></label> '.
 			form::textarea('post_excerpt',50,5,html::escapeHTML($post_excerpt)).
 			'</p>',
@@ -492,6 +479,6 @@
 		
 		"post_notes" =>
-			'<p class="area" id="notes-area"><label for="post_notes">'.__('Personal notes:').'<span class="form-note">'.
-			__('Add unpublished notes.').'</span></label>'.
+			'<p class="area" id="notes-area"><label for="post_notes">'.__('Personal notes:').' <span class="form-note">'.
+			__('Unpublished notes.').'</span></label>'.
 			form::textarea('post_notes',50,5,html::escapeHTML($post_notes)).
 			'</p>'
@@ -545,5 +532,5 @@
 	
 	foreach ($sidebar_items as $id => $c) {
-		echo '<div id="'.$id.'" class="box">'.
+		echo '<div id="'.$id.'" class="sb-box">'.
 			'<h4>'.$c['title'].'</h4>';
 		foreach ($c['items'] as $e_name=>$e_content) {
@@ -603,5 +590,5 @@
 	
 	echo
-	'<p class="top-add"><a class="button add onblog_link" href="#comment-form">'.__('Add a comment').'</a></p>';
+	'<p class="top-add"><a class="button add" href="#comment-form">'.__('Add a comment').'</a></p>';
 
 	if ($has_action) {
Index: plugins/simpleMenu/index.php
===================================================================
--- plugins/simpleMenu/index.php	(revision 1636)
+++ plugins/simpleMenu/index.php	(revision 1722)
@@ -23,46 +23,30 @@
 
 # Liste des catégories
-$categories_combo = array();
 $categories_label = array();
-try {
-	$rs = $core->blog->getCategories(array('post_type'=>'post'));
-	while ($rs->fetch()) {
-		$categories_combo[] = new formSelectOption(
-			str_repeat('&nbsp;&nbsp;',$rs->level-1).($rs->level-1 == 0 ? '' : '&bull; ').html::escapeHTML($rs->cat_title),
-			$rs->cat_url
-		);
-		$categories_label[$rs->cat_url] = html::escapeHTML($rs->cat_title);
-	}
-} catch (Exception $e) { }
-
+$rs = $core->blog->getCategories(array('post_type'=>'post'));
+$categories_combo = dcAdminCombos::getCategoriesCombo($rs);
+unset($categories_combo[__('(No cat)')]);
+$rs->moveStart();
+while ($rs->fetch()) {
+	$categories_label[$rs->cat_id] = html::escapeHTML($rs->cat_title);
+}
 # Liste des langues utilisées
-$langs_combo = array();
-try {
-	$rs = $core->blog->getLangs(array('order'=>'asc'));
-	if ($rs->count() > 1)
-	{
-		$all_langs = l10n::getISOcodes(0,1);
-		while ($rs->fetch()) {
-			$lang_name = isset($all_langs[$rs->post_lang]) ? $all_langs[$rs->post_lang] : $rs->post_lang;
-			$langs_combo[$lang_name] = $rs->post_lang;
-		}
-		unset($all_langs);
-	}
-	unset($rs);
-} catch (Exception $e) { }
+$langs_combo = dcAdminCombos::getLangscombo(
+	$core->blog->getLangs(array('order'=>'asc'))
+);
 
 # Liste des mois d'archive
-$months_combo = array();
-try {
-	$rs = $core->blog->getDates(array('type'=>'month'));
-	$months_combo[__('All months')] = '-';
-	$first_year = $last_year = 0;
-	while ($rs->fetch()) {
-		$months_combo[dt::str('%B %Y',$rs->ts())] = $rs->year().$rs->month();
-		if (($first_year == 0) || ($rs->year() < $first_year)) $first_year = $rs->year();
-		if (($last_year == 0) || ($rs->year() > $last_year)) $last_year = $rs->year();
-	}
-	unset($rs);
-} catch (Exception $e) { }
+$rs = $core->blog->getDates(array('type'=>'month'));
+$months_combo = array_merge(
+	array(__('All months') => '-'),
+	dcAdmincombos::getDatesCombo($rs)
+);
+
+$first_year = $last_year = 0;
+while ($rs->fetch()) {
+	if (($first_year == 0) || ($rs->year() < $first_year)) $first_year = $rs->year();
+	if (($last_year == 0) || ($rs->year() > $last_year)) $last_year = $rs->year();
+}
+unset($rs);
 
 # Liste des pages -- Doit être pris en charge plus tard par le plugin ?
@@ -395,5 +379,4 @@
 	dcPage::success(__('Menu items have been successfully updated.'));
 }
-
 if ($step)
 {
Index: tests/functional/js/fix_include.js
===================================================================
--- tests/functional/js/fix_include.js	(revision 1703)
+++ tests/functional/js/fix_include.js	(revision 1724)
@@ -10,2 +10,12 @@
 dotclear.msg.confirm_delete_posts = 'confirm %s delete';
 dotclear.msg.confirm_delete_comments = 'confirm %s delete';
+
+dotclear.jsUpload = {msg:{}};
+dotclear.jsUpload.msg.cancel = 'cancel';
+dotclear.jsUpload.msg.send = 'send';
+dotclear.jsUpload.msg.error = 'error';
+dotclear.jsUpload.msg.file_successfully_uploaded = 'file succesfully uploaded';
+
+dotclear.msg.enhanced_uploader_activate = 'Temporarily activate enhanced uploader';
+dotclear.msg.enhanced_uploader_disable = 'Temporarily disable enhanced uploader';
+
Index: tests/functional/lib/jasmine-jquery-bootstrap.js
===================================================================
--- tests/functional/lib/jasmine-jquery-bootstrap.js	(revision 1602)
+++ tests/functional/lib/jasmine-jquery-bootstrap.js	(revision 1724)
@@ -1,28 +1,29 @@
 (function() {
-    jasmine.getFixtures().fixturesPath = 'fixtures';
+	jasmine.getFixtures().fixturesPath = 'fixtures';
+	jasmine.getStyleFixtures().fixturesPath = '../../admin/style';
 
-    var jasmineEnv = jasmine.getEnv();
-    jasmineEnv.updateInterval = 1000;
+	var jasmineEnv = jasmine.getEnv();
+	jasmineEnv.updateInterval = 1000;
 
-    var htmlReporter = new jasmine.HtmlReporter();
+	var htmlReporter = new jasmine.HtmlReporter();
 
-    jasmineEnv.addReporter(htmlReporter);
+	jasmineEnv.addReporter(htmlReporter);
 
-    jasmineEnv.specFilter = function(spec) {
-	return htmlReporter.specFilter(spec);
-    };
+	jasmineEnv.specFilter = function(spec) {
+		return htmlReporter.specFilter(spec);
+	};
 
-    var currentWindowOnload = window.onload;
+	var currentWindowOnload = window.onload;
 
-    window.onload = function() {
-	if (currentWindowOnload) {
-	    currentWindowOnload();
+	window.onload = function() {
+		if (currentWindowOnload) {
+			currentWindowOnload();
+		}
+		execJasmine();
+	};
+
+	function execJasmine() {
+		jasmineEnv.execute();
 	}
-	execJasmine();
-    };
-
-    function execJasmine() {
-	jasmineEnv.execute();
-    }
 
 })();
Index: tests/functional/spec/media_manager.js
===================================================================
--- tests/functional/spec/media_manager.js	(revision 1724)
+++ tests/functional/spec/media_manager.js	(revision 1724)
@@ -0,0 +1,31 @@
+describe("Enhanced Media Manager", function() {
+	describe("Starting with media manager enhanced disabled", function() {
+		it("Enhanced uploader can be temporarily enabled", function() {
+			loadFixtures('form_media_disabled.html');
+			loadStyleFixtures('jsUpload/style.css');
+			
+			$('#fileupload').enhancedUploader();
+			expect($('p.clear a.enhanced-toggle').text()).toBe(dotclear.msg.enhanced_uploader_activate);
+			expect($('#fileupload .button.start')).not.toBeDisabled();
+
+			$('p.clear a.enhanced-toggle').click();
+			expect($('p.clear a.enhanced-toggle').text()).toBe(dotclear.msg.enhanced_uploader_disable);			
+			expect($('.button.start')).toBeDisabled();
+		});
+	});
+
+	describe("Starting with media manager enhanced enabled", function() {
+		it("Enhanced uploader can be temporarily disabled", function() {
+			loadFixtures('form_media_enabled.html');
+			loadStyleFixtures('jsUpload/style.css');
+
+			$('#fileupload').enhancedUploader();
+			expect($('p.clear a.enhanced-toggle').text()).toBe(dotclear.msg.enhanced_uploader_disable);
+			expect($('.button.start')).toBeDisabled();
+
+			$('p.clear a.enhanced-toggle').click();
+			expect($('p.clear a.enhanced-toggle').text()).toBe(dotclear.msg.enhanced_uploader_activate);
+			expect($('#fileupload .button.start')).not.toBeDisabled();
+		});
+	});
+});
Index: tests/functional/spec/page_tabs.js
===================================================================
--- tests/functional/spec/page_tabs.js	(revision 1737)
+++ tests/functional/spec/page_tabs.js	(revision 1737)
@@ -0,0 +1,92 @@
+describe("tabs method (admin/js/pageTabs.js)", function() {
+	
+	it("Construct tabs using div content", function() {
+		
+		loadFixtures('tabs.html');
+		
+		expect($('#tab-1')).toBeVisible();
+		expect($('#tab-2')).toBeVisible();
+		expect($('#tab-3')).toBeVisible();
+		
+		expect($('.part-tabs')).not.toExist();
+		
+		$.pageTabs('tab-1');
+		
+		expect($('#tab-1')).toBeVisible();
+		expect($('#tab-2')).not.toBeVisible();
+		expect($('#tab-3')).not.toBeVisible();
+		
+		expect($('.part-tabs ul li#part-tabs-tab-1 a[href=#tab-1]')).toExist();
+		expect($('.part-tabs ul li#part-tabs-tab-2 a[href=#tab-2]')).toExist();
+		expect($('.part-tabs ul li#part-tabs-tab-3 a[href=#tab-3]')).toExist();
+	
+		expect($('.part-tabs ul li#part-tabs-tab-1')).toHaveClass('part-tabs-active');
+		
+	});
+	
+	it("Change tabs when changing the hash", function() {
+		
+		runs(function() {        
+            loadFixtures('tabs-iframe.html');
+        });
+		
+		waitsFor(function() {
+            return $("#testtab").contents().find('#tab-3').get(0);
+        }, 10000);
+		
+		runs(function() {
+			f$ = $("#testtab").get(0).contentWindow.$;
+			f$.pageTabs('tab-1');
+
+			expect(f$('#tab-1').get(0)).toBeVisible();
+			expect(f$('#tab-2').get(0)).not.toBeVisible();
+			
+			expect(f$('.part-tabs ul li#part-tabs-tab-1').get(0)).toHaveClass('part-tabs-active');
+			expect(f$('.part-tabs ul li#part-tabs-tab-2').get(0)).not.toHaveClass('part-tabs-active');
+
+            $("#testtab").attr('src', $("#testtab").attr('src')+'#tab-2');
+        });
+		
+		waitsFor(function() {
+			f$ = $("#testtab").get(0).contentWindow.$;
+            return f$('#tab-1').is(':not(:visible)');
+        }, 10000);
+		
+		runs(function() {
+			f$ = $("#testtab").get(0).contentWindow.$;
+			
+    		expect(f$('#tab-2').get(0)).toBeVisible();
+
+			expect(f$('.part-tabs ul li#part-tabs-tab-1').get(0)).not.toHaveClass('part-tabs-active');
+			expect(f$('.part-tabs ul li#part-tabs-tab-2').get(0)).toHaveClass('part-tabs-active');
+			
+        });
+		
+	});
+	
+	it("Load the correct tab with the correct hash", function() {
+		
+		runs(function() {        
+            loadFixtures('tabs-iframe.html');
+            $("#testtab").attr('src', $("#testtab").attr('src')+'#tab-3');
+        });
+		
+		waitsFor(function() {
+			cond1 = $("#testtab").attr('src').split('#')[1] != '';
+			cond2 = $("#testtab").contents().find('#tab-3').get(0);
+            return cond1 && cond2;
+        }, 10000);
+		
+		runs(function() {
+			f$ = $("#testtab").get(0).contentWindow.$;
+			f$.pageTabs('tab-1');
+			
+			expect(f$('#tab-1').get(0)).not.toBeVisible();
+			expect(f$('#tab-3').get(0)).toBeVisible();
+			
+			expect(f$('.part-tabs ul li#part-tabs-tab-1').get(0)).not.toHaveClass('part-tabs-active');
+			expect(f$('.part-tabs ul li#part-tabs-tab-3').get(0)).toHaveClass('part-tabs-active');
+        });
+		
+	});
+});
Index: tests/functional/spec/users_actions.js
===================================================================
--- tests/functional/spec/users_actions.js	(revision 1703)
+++ tests/functional/spec/users_actions.js	(revision 1724)
@@ -1,25 +1,25 @@
 describe("updatePermissionsForm method (admin/js/_users_actions.js)", function() {
-    it("Click admin persmission must checked all associated permissions", function() {
-	loadFixtures('normal.html');
-	$('#permissions-form').updatePermissionsForm();
-	var permissions = ['usage','publish','delete','contentadmin','categories'];
+	it("Click admin persmission must checked all associated permissions", function() {
+		loadFixtures('normal.html');
+		$('#permissions-form').updatePermissionsForm();
+		var permissions = ['usage','publish','delete','contentadmin','categories'];
 
-	$('input[name="perm[default][admin]"]').click();
-	for (var _i=0,_len=permissions.length;_i<_len;_i++) {
-	    expect($('input[name="perm[default]['+permissions[_i]+']"]')).toBeChecked();
-	    expect($('input[name="perm[default]['+permissions[_i]+']"]')).toBeDisabled();
-	}
-    });
+		$('input[name="perm[default][admin]"]').click();
+		for (var _i=0,_len=permissions.length;_i<_len;_i++) {
+			expect($('input[name="perm\\[default\\]\\['+permissions[_i]+'\\]"]')).toBeChecked();
+			expect($('input[name="perm\\[default\\]\\['+permissions[_i]+'\\]"]')).toBeDisabled();
+		}
+	});
 
-    it("Click contentadmin persmission must checked all associated permissions", function() {
-	loadFixtures('normal.html');
-	$('#permissions-form').updatePermissionsForm();
-	var permissions = ['usage','publish','delete'];
+	it("Click contentadmin persmission must checked all associated permissions", function() {
+		loadFixtures('normal.html');
+		$('#permissions-form').updatePermissionsForm();
+		var permissions = ['usage','publish','delete'];
 
-	$('input[name="perm[default][contentadmin]"]').click();
-	for (var _i=0,_len=permissions.length;_i<_len;_i++) {
-	    expect($('input[name="perm[default]['+permissions[_i]+']"]')).toBeChecked();
-	    expect($('input[name="perm[default]['+permissions[_i]+']"]')).toBeDisabled();
-	}
-    });
+		$('input[name="perm[default][contentadmin]"]').click();
+		for (var _i=0,_len=permissions.length;_i<_len;_i++) {
+			expect($('input[name="perm[default]['+permissions[_i]+']"]')).toBeChecked();
+			expect($('input[name="perm[default]['+permissions[_i]+']"]')).toBeDisabled();
+		}
+	});
 });
